//WHICHLIB JOB (001),'ASM WHICHLIB    ',CLASS=A,MSGCLASS=X              00000121
//       EXEC ASMFCL,                                                   00000213
//            PARM.ASM='LIST,LOAD,NODECK,XREF(SHORT)',                  00000319
//            REGION.ASM=1M,                                            00000411
//            MAC1='SYS1.AMODGEN'                                       00000520
//ASM.SYSPRINT DD SYSOUT=*                                              00000613
//ASM.SYSIN DD *                                                        00000721
         PRINT ON,NOGEN                                                 00000821
         TITLE 'RETURN LIBRARY WHERE LOAD MODULE EXISTS'                00000921
*_DOC_***************************************************************** 00001022
*                                                                     * 00001122
* THE SINGULAR FUNCTION OF THIS PROGRAM IS TO DETERMINE IF A LOAD     * 00001222
* MODULE IS AVAILABLE FOR EXECUTION AND, IF NOT, SET THE RETURN CODE  * 00001322
* TO 0001. IF THE LOAD MODULE IS AVAILABLE, THE RETURN CODE WILL BE   * 00001422
* SET TO 0000.  IF AN OPTIONAL SYSPRINT DD STATEMENT IS PROVIDED, A   * 00001522
* SINGLE LINE IS PRODUCED IDENTIFYING THE LIBRARY WHERE THE LOAD      * 00001622
* MODULE WAS FOUND.                                                   * 00001722
*                                                                     * 00001822
* THE PROGRAM IS SELF CONTAINED; SIMPLY ASSEMBLE AND LINK AND IT IS   * 00001922
* READY TO USE.                                                       * 00002022
*                                                                     * 00002122
* THE JCL TO EXECUTE WHICHLIB IS:                                     * 00002222
*   1) //         EXEC PGM=WHICHLIB,PARM='????????' <-MODULE TO FIND  * 00002322
*   2) //SYSPRINT DD  SYSOUT=*                      <-OPTIONAL        * 00002422
*                                                                     * 00002522
*********************************************************************** 00002622
WHICHLIB CSECT                                                          00002721
         B     BEGIN-*(,R15)           BRANCH AROUND EYECATCHER         00002821
         DC    AL1(BEGIN-ID)                                            00002921
ID       DC    C'WHICHLIB '                                             00003021
         DC    C'&SYSDATE '                                             00003122
         DC    C'&SYSTIME - '                                           00003222
BEGIN    DS    0H                                                       00003322
         SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00003422
         LR    R12,R15                 INITIALIZE BASE REGISTER         00003522
         USING WHICHLIB,R12            ESTABLISH ADDRESSABILITY         00003622
         LR    R6,R1                   SAVE PARAMETER ADDRESS IN R6     00003722
         LA    R10,SAVEAREA            LOAD MY SAVE AREA ADDR           00003822
         ST    R10,8(,R13)             STORE CALLER'S SAVE AREA ADDR    00003922
         ST    R13,4(,R10)             BACK CHAIN MY SAVE AREA ADDR     00004022
         LR    R13,R10                 ESTABLISH MY SAVE AREA           00004122
         SPACE 1                                                        00004222
         L     R6,0(,R6)               POINT TO EXEC PARM               00004322
         LH    R7,0(,R6)               GET LENGTH OF PARM FIELD         00004422
         LTR   R7,R7                   ANY PARM?                        00004522
         BZ    GOBACK                  NO, RETURN TO CALLER             00004622
         LA    R6,2(R6)                FIRST CHAR OF EXEC PARM          00004722
         BCTR  R7,0                    DECREMENT FOR MOVE               00004822
         LA    R2,BLDLNAME             GET ADDRESS TO MOVE TO           00004922
         EX    R7,MOVEPARM             MOVE NAME INTO BLDL              00005022
         B     SCANTIOT                GO FIND SYSPRINT                 00005122
MOVEPARM MVC   0(*-*,R2),0(R6)         EXECUTE MOVE FOR PARM            00005222
*                                                                       00005322
* LOOP THROUGH TIOT LOOKING FOR SYSPRINT DD                             00005422
*                                                                       00005522
SCANTIOT L     R1,CVTPTR               ADDRESS OF CVT                   00005622
         L     R1,CVTTCBP-CVTMAP(,R1)  TCB TABLE                        00005722
         L     R1,4(,R1)               TCBOLD (CURRENT)                 00005822
         L     R1,TCBTIO-TCB(,R1)      TIOT                             00005922
         LA    R1,TIOENTRY-TIOT1(,R1)  LOAD PAST TIOT HEADER            00006022
         USING TIOENTRY,R1             ESTABLISH ADDRESSABILITY         00006122
         SR    R2,R2                                                    00006222
LOOPTIOT IC    R2,TIOELNGH             GET ENTRY LENGTH                 00006322
         LTR   R2,R2                   LAST ENTRY PASSED?               00006422
         BZ    DONETIOT                YES, GET OUT                     00006522
         CLC   TIOEDDNM,=C'SYSPRINT'   IS THIS SYSPRINT DD?             00006622
         BNE   NEXTTIOT                NO, CHECK NEXT                   00006722
         MVI   SYSPRT,C'Y'             SET FLAG FOR SYSPRINT SUPPLIED   00006822
         B     DONETIOT                FINISHED, EXIT                   00006922
NEXTTIOT AR    R1,R2                   BUMP TO NEXT TIOT ENTRY          00007022
         B     LOOPTIOT                LOOP                             00007122
DONETIOT DS    0H                      FINISHED WITH TIOT               00007222
         DROP  R1                                                       00007322
*                                                                       00007422
* SEE IF LOAD MODULE CAN BE FOUND                                       00007522
*                                                                       00007622
         BLDL  0,BLDLLIST              BLDL FROM TASK/STEP/JOBLIB       00007722
         LTR   R15,R15                 WAS MODULE NAME FOUND ?          00007822
         BZ    PRTREQ                  YES, GO SEE IF SYSPRINT PROVIDED 00007922
NOTFOUND MVC   RETCODE,=F'1'           SET RETCODE = 1                  00008022
         B     GOBACK                  RETURN                           00008122
PRTREQ   CLI   SYSPRT,C'Y'             WAS SYSPRINT PROVIDED?           00008222
         BNE   GOBACK                  NO, JUST RETURN                  00008322
         SPACE 1                                                        00008422
         MVC   MODNAME,BLDLNAME        MOVE MODULE NAME TO PRINT        00008522
*                                                                       00008622
* SET WHICH LIBRARY WAS MODULE FOUND IN                                 00008722
*   SEE: (SYS1.AMODGEN(IHAPDS)@PDS2LIBF)                                00008822
*                                                                       00008922
LIBSTAT  MVC   LIBRARY,JOBSTEP                                          00009022
         CLI   LOCCODE,X'02'           IS IT IN JOBSTEP ?               00009122
         BE    CONCATON                YES                              00009222
         MVC   LIBRARY,LINKLST                                          00009322
         CLI   LOCCODE,X'01'           IS IT IN THE LINKLST ?           00009422
         BE    LINKLIST                YES                              00009522
         MVC   LIBRARY(16),UNKNLIB     UNKNOWN LIBRARY                  00009622
         B     PRINTIT                 GO PRINT                         00009722
*                                                                       00009822
* SET CONCATENATION NUMBER                                              00009922
*                                                                       00010022
CONCATON SR    R1,R1                                                    00010122
         IC    R1,CONCAT#              CONCATENATION NUMBER TO R1       00010222
         LA    R1,1(,R1)               ADJUST FOR ZERO BASE             00010322
         CVD   R1,DWORK                CONVERT TO DECIMAL               00010422
         ED    CWORK,DWORK+6           EDIT                             00010522
         MVC   CONCAT,CWORK+2          MOVE TO PRINT                    00010622
         B     PRINTIT                 GO PRINT                         00010722
         SPACE 1                                                        00010822
*                                                                       00010922
* FIND LINKLIST LIBRARY INFORMATION                                     00011022
*                                                                       00011122
LINKLIST SR    R8,R8                                                    00011222
         IC    R8,CONCAT#              LINKLIST ENTRY NUMBER TO R8      00011322
         LA    R8,1(,R8)               ADJUST FOR ZERO BASE             00011422
         CVD   R8,DWORK                CONVERT TO DECIMAL               00011522
         ED    CWORK,DWORK+6           EDIT                             00011622
         MVC   CONCAT,CWORK+2          MOVE TO PRINT                    00011722
*                                                                       00011822
* READ SYS1.PARMLIB(IEASYS00) TO GET LNKLST PARM MEMBER                 00011922
*                                                                       00012022
         MVC   RBVERB,=AL1(S99VRBAL)   SET VERB CODE TO ALLOC           00012122
         MVC   RBTEXTA,=A(TEXTLST1)    SET TU LIST FOR ALLOC            00012222
         BAL   R14,DYNALLOC            ALLOCATE PARMLIB (IEASYS00)      00012322
         LTR   R15,R15                 SUCCESS?                         00012422
         BNZ   PRINTIT                 NO, JUST GO PRINT                00012522
         SPACE 1                                                        00012622
         OPEN  (PARMLIB,(INPUT))       OPEN PARMLIB (IEASYS00)          00012722
PREADI   GET   PARMLIB,PARMSTMT        READ PARMLIB (IEASYS00)          00012822
         CLC   PARMSTMT(4),=CL4'LNK='  IS THIS LNKLST ID?               00012922
         BNE   PREADI                  NO, CONTINUE READING             00013022
         CLOSE PARMLIB                 CLOSE PARMLIB (IEASYS00)         00013122
         MVC   RBVERB,=AL1(S99VRBUN)   SET VERB CODE TO FREE            00013222
         MVC   RBTEXTA,=A(TEXTLST2)    SET TU LIST FOR FREE             00013322
         BAL   R14,DYNALLOC            UN-ALLOCATE PARMLIB              00013422
         LTR   R15,R15                 SUCCESS?                         00013522
         BNZ   PRINTIT                 NO, JUST GO PRINT                00013622
         SPACE 1                                                        00013722
         MVC   $MEM(6),=CL6'LNKLST'    SET MEMBER NAME TO LNKLST        00013822
         MVC   $MEM+6(2),PARMSTMT+4    PLUS ID FROM IEASYS00            00013922
*                                                                       00014022
* READ SYS1.PARMLIB(LNKLST??) TO GET LINK LIST DATASET NAMES            00014122
*                                                                       00014222
         MVC   RBVERB,=AL1(S99VRBAL)   SET VERB CODE TO ALLOC           00014322
         MVC   RBTEXTA,=A(TEXTLST1)    SET TU LIST FOR ALLOC            00014422
         BAL   R14,DYNALLOC            ALLOCATE PARMLIB (LNKLST??)      00014522
         LTR   R15,R15                 SUCCESS?                         00014622
         BNZ   PRINTIT                 NO, JUST GO PRINT                00014722
         SPACE 1                                                        00014822
         OPEN  (PARMLIB,(INPUT))       OPEN PARMLIB (LNKLST??)          00014922
         MVI   LLABORT,C'N'            IF NOT FOUND                     00015022
         XR    R7,R7                   TO COUNT STATEMENTS READ         00015122
PREADL   GET   PARMLIB,PARMSTMT        READ PARMLIB (LNKLST??)          00015222
         LA    R7,1(,R7)               COUNT STATEMENT READ             00015322
         CR    R7,R8                   IS THIS THE ONE WE NEED?         00015422
         BL    PREADL                  R7<R8, CONTINUE READING          00015522
         BNE   PREADC                  R7\=R8, CLOSE & CONTINUE         00015622
         SPACE 1                                                        00015722
         MVI   LLABORT,C'Y'            R7=R8, FOUND                     00015822
         SPACE 1                                                        00015922
PREADC   CLOSE PARMLIB                 CLOSE PARMLIB (LNKLST??)         00016022
         MVC   RBVERB,=AL1(S99VRBUN)   SET VERB CODE TO FREE            00016122
         MVC   RBTEXTA,=A(TEXTLST2)    SET TU LIST FOR FREE             00016222
         BAL   R14,DYNALLOC            UN-ALLOCATE PARMLIB              00016322
         SPACE 1                                                        00016422
         CLI   LLABORT,C'N'            WAS LIBRARY FOUND?               00016522
         BE    PRINTIT                 NO, JUST GO PRINT                00016622
         SPACE 1                                                        00016722
         LA    R1,PARMSTMT             ADDRESS PARM STATEMENT           00016822
PSCANL   CLI   0(R1),KCOMMA            FOUND COMMA?                     00016922
         BE    PSCANX                  YES, PROCESS                     00017022
         CLI   0(R1),KSPACE            FOUND SPACE?                     00017122
         BE    PSCANX                  YES, PROCESS                     00017222
         CLI   0(R1),KLPAREN           FOUND LEFT PAREN?                00017322
         BE    PSCANX                  YES, PROCESS                     00017422
         LA    R1,1(,R1)               INCREMENT SCAN POSITION          00017522
         B     PSCANL                  LOOP TO CONTINUE SCANNING        00017622
         SPACE 1                                                        00017722
PSCANX   S     R1,=A(PARMSTMT)         COMPUTE LENGTH OF DSN            00017822
GETDSN   MVI   CAMDSN,KSPACE           CLEAR FIELD TO                   00017922
         MVC   CAMDSN+1(L'CAMDSN-1),CAMDSN   SPACES TO RECEIVE DSN      00018022
         BCTR  R1,0                    DECREMENT FOR EX                 00018122
         EX    R1,MOVEDSN              MOVE DSN TO CAMLST AREA          00018222
         LA    R4,LLINFO               ADDRESS PRINT AREA               00018322
         MVC   0(44,R4),CAMDSN         MOVE DSN TO PRINT                00018422
         AR    R4,R1                   ADDRESS PRINT AREA PAST DSN      00018522
         LA    R4,2(,R4)               BUMP TO NEXT PRINT LOCATION      00018622
         MVC   0(2,R4),=C'ON'          MOVE LITERAL TO PRINT            00018722
         LA    R4,3(,R4)               BUMP TO NEXT OUTPUT POSITION     00018822
         SPACE 1                                                        00018922
         LOCATE BYNAME                 LOCATE                           00019022
         MVC   0(6,R4),VSERIAL         MOVE VOLSER TO PRINT             00019122
         B     PRINTIT                 GO PRINT                         00019222
         SPACE 1                                                        00019322
MOVEDSN  MVC   CAMDSN(*-*),PARMSTMT    EXECUTED MOVE                    00019422
         SPACE 1                                                        00019522
PRINTIT  OPEN  (SYSPRINT,(OUTPUT))     OPEN SYSPRINT                    00019622
         PUT   SYSPRINT,FOUNDMSG       WRITE PRINT LINE                 00019722
         CLOSE SYSPRINT                CLOSE SYSPRINT                   00019822
         SPACE 1                                                        00019922
GOBACK   DS    0H                      RETURN TO CALLER                 00020022
         L     R13,4(,R13)             RELOAD PREVIOUS SAVE AREA        00020122
         L     R15,RETCODE             LOAD RETURN CODE                 00020222
         RETURN (14,12),RC=(15)                                         00020322
         SPACE 1                                                        00020422
*                                                                       00020522
* ALLOCATE DSN(MEMBER)                                                  00020622
*                                                                       00020722
DYNALLOC DS    0H                                                       00020822
         LA    R1,RBA                  LOAD REQUEST BLOCK ADDRESS       00020922
         DYNALLOC                      CALL DYNAMIC ALLOCATE SVC        00021022
         BR    R14                     RETURN                           00021122
         SPACE 1                                                        00021222
FOUNDMSG DS    0CL133                                                   00021322
         DC    CL1'1'                                                   00021422
MODNAME  DC    CL8'        '                                            00021522
         DC    CL14' WAS FOUND IN '                                     00021622
LIBRARY  DC    CL12'            '                                       00021722
         DC    CL1'('                                                   00021822
CONCAT   DC    CL2' '                                                   00021922
         DC    CL1')'                                                   00022022
         DC    CL1' '                                                   00022122
LLINFO   DC    CL93' '                                                  00022222
JOBSTEP  DC    CL12'JOB/STEP LIB'                                       00022322
LINKLST  DC    CL12'LINKLIST LIB'                                       00022422
UNKNLIB  DC    CL16'UNKNOWN LIB     '                                   00022522
DWORK    DS    D                       CONVERT TO DECIMAL WORK          00022622
CWORK    DC    XL4'40212020'           CONVERT TO PRINTABLE WORK        00022722
         SPACE 1                                                        00022822
BLDLLIST DS    0H                      PARM LIST FOR BLDL               00022922
         DC    H'01'                   NUMBER OF ENTRIES                00023022
         DC    H'14'                   BYTES PER ENTRY                  00023122
BLDLNAME DC    CL8' '                  NAME OF LOAD MODULE              00023222
TTR1REC  DC    CL3'0'                  TTR OF FIRST RECORD              00023322
CONCAT#  DC    X'0'                    K BYTE, CONCATENATED NUMBER      00023422
LOCCODE  DC    X'0'                    Z BYTE, LOCATION CODE            00023522
FLGUSRD  DC    X'0'                    C BYTE, FLAG AND USER DATA LEN   00023622
         SPACE 1                                                        00023722
RBA      DC    A(X'80000000'+RB)       DYNALLOC REQUEST BLOCK ADDRESS   00023822
RB       DC    AL1(S99RBEND-S99RB)     DYNALLOC REQUEST BLOCK LENGTH    00023922
RBVERB   DC    AL1(S99VRBAL)           DYNALLOC VERB 01=ALLOC/02=FREE   00024022
RBFLAGS1 DC    AL1(S99NOMNT,0)         DYNALLOC FLAGS 1                 00024122
*                  S99NOMNT                 DO NOT MOUNT VOLUMES        00024222
RBERROR  DC    AL2(0)                  DYNALLOC ERROR CODE              00024322
RBINFO   DC    AL2(0)                  DYNALLOC INFORMATION CODE        00024422
RBTEXTA  DC    A(TEXTLST1)             DYNALLOC ADDR OF TEXT UNIT LIST  00024522
RBEXTNA  DC    A(0)                    DYNALLOC ADDR OF RB EXTENSION    00024622
RBFLAGS2 DC    A(0)                    DYNALLOC FLAGS 2                 00024722
         SPACE 1                                                        00024822
TEXTLST1 DC    A(TUDD)                 DYNALLOC TU LIST (ALLOC)         00024922
         DC    A(TUDSN)                                                 00025022
         DC    A(TUMEM)                                                 00025122
         DC    A(X'80000000'+TUDISP)                                    00025222
TEXTLST2 DC    A(TUDD)                 DYNALLOC TU LIST (FREE)          00025322
         DC    A(X'80000000'+TUFREE)                                    00025422
         SPACE 1                                                        00025522
TUDD     DC    Y(DALDDNAM,1,8),CL8'PARMLIB' TU: DD NAME                 00025622
TUDSN    DC    Y(DALDSNAM,1)                TU: DSN                     00025722
$DSNLEN  DC    AL2(L'$DSN)                                              00025822
$DSN     DC    CL44'SYS1.PARMLIB'                                       00025922
TUMEM    DC    Y(DALMEMBR,1)                TU: MEMBER NAME             00026022
$MEMLEN  DC    AL2(L'$MEM)                                              00026122
$MEM     DC    CL8'IEASYS00'                                            00026222
TUDISP   DC    Y(DALSTATS,1,1)              TU: DISP=SHR                00026322
         DC    X'08'                                                    00026422
TUFREE   DC    Y(DUNUNALC,0)                TU: FREE                    00026522
         SPACE 1                                                        00026622
BYNAME   CAMLST NAME,CAMDSN,,CAMWORK   LOCATE ARGUMENTS                 00026722
CAMDSN   DS    CL44                    DS NAME TO SEARCH FOR            00026822
CAMWORK  DS    0D                      CAMLST WORK AREA                 00026922
         DC    265CL1' '                                                00027022
         ORG   CAMWORK+6                                                00027122
VSERIAL  DS    CL6                     VOLUME SERIAL RETURNED           00027222
         ORG                                                            00027322
         SPACE 1                                                        00027422
SAVEAREA DC    18F'0'                  MY SAVE AREA                     00027522
SYSPRT   DC    CL1'N'                  FLAG FOR SYSPRINT DD SUPPLIED    00027622
RETCODE  DC    F'0'                    RETURN CODE                      00027722
LLABORT  DC    CL1'N'                  FLAG FOR LINKLISTLIB NOT FOUND   00027822
         PRINT ON,NOGEN                                                 00027922
SYSPRINT DCB   DDNAME=SYSPRINT,MACRF=PM,RECFM=FBA,LRECL=133,           C00028022
               BLKSIZE=1330,DSORG=PS                                    00028122
PARMLIB  DCB   DDNAME=PARMLIB,MACRF=GM,RECFM=FB,LRECL=80,              C00028222
               BLKSIZE=80,DSORG=PS                                      00028322
PARMSTMT DS    CL80                PARMLIB INPUT AREA                   00028422
R0       EQU   0                                                        00028522
R1       EQU   1                                                        00028622
R2       EQU   2                                                        00028722
R3       EQU   3                                                        00028822
R4       EQU   4                                                        00028922
R5       EQU   5                                                        00029022
R6       EQU   6                                                        00029122
R7       EQU   7                                                        00029222
R8       EQU   8                                                        00029322
R9       EQU   9                                                        00029422
R10      EQU   10                                                       00029522
R11      EQU   11                                                       00029622
R12      EQU   12                                                       00029722
R13      EQU   13                                                       00029822
R14      EQU   14                                                       00029922
R15      EQU   15                                                       00030022
*                                                                       00030122
KSPACE   EQU   X'40'                   SPACE                            00030222
KSTAR    EQU   C'*'                    ASTERISK                         00030322
KCOMMA   EQU   C','                    COMMA                            00030422
KLPAREN  EQU   C'('                    LEFT PAREN                       00030522
KRPAREN  EQU   C')'                    RIGHT PAREN                      00030622
*                                                                       00030722
         CVT   DSECT=YES                                                00030822
MYTIOT   DSECT ,                                                        00030922
         IEFTIOT1 ,                                                     00031022
         IKJTCB   ,                                                     00031122
         IEFZB4D0 ,                    SVC99 REQUEST BLOCK              00031222
         IEFZB4D2 ,                    SVC99 TEXT UNITS                 00031322
         END                                                            00031422
//LKED.SYSLMOD DD DISP=SHR,DSN=SYSC.LINKLIB                             00031522
//LKED.SYSPRINT DD SYSOUT=*                                             00031622
//LKED.SYSIN DD *                                                       00031722
  ENTRY WHICHLIB                                                        00031822
  NAME WHICHLIB(R)                                                      00031922
//                                                                      00032022


